## composite 0.006

=== CMakeLists.txt ===
######################################################################
### Composite Build Script (CMake)                                 ###
### http://gabe.is-a-geek.org/composite/                           ###
######################################################################

CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

######################################################################
### PROJECT META-INFO                                              ###
######################################################################

PROJECT(composite)
SET(VERSION_MAJOR "0")
SET(VERSION_MINOR "006")
#SET(VERSION_PATCH "")
SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}")

######################################################################
### CMAKE SETUP                                                    ###
######################################################################

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules")

# The CMake Policy mechanism is designed to help keep existing
# projects building as new versions of CMake introduce changes in
# behavior.
# http://www.cmake.org/cmake/help/cmake2.6docs.html#command:cmake_policy
IF(COMMAND CMAKE_POLICY)
#	CMAKE_POLICY(SET CMP0005 NEW)
	CMAKE_POLICY(SET CMP0003 NEW)   # add_library
ENDIF(COMMAND CMAKE_POLICY)

######################################################################
### CONFIGURATION OPTIONS                                          ###
######################################################################

OPTION(WANT_LRDF
  "Include LRDF (Lightweight Resource Description Framework with special support for LADSPA plugins) support <http://sourceforge.net/projects/lrdf/>"
  OFF
  )

OPTION(WANT_LIBARCHIVE
  "Enable use of libarchive instead of libtar and libz.  Windows builds will usually want to set this one."
  OFF )


######################################################################
### REQUIRED LIBRARIES                                             ###
######################################################################

### See src/Tritium/CMakeLists.txt
### See src/composite-gui/CMakeLists.txt

######################################################################
### BUILD/INSTALL SETUP                                            ###
######################################################################

SET(DATA_PATH "${CMAKE_INSTALL_PREFIX}/share/composite/data")

######################################################################
### CONFIGURING THE SOFTWARE....                                   ###
######################################################################

CONFIGURE_FILE(config.h.in config.h)
CONFIGURE_FILE(version.cpp.in version.cpp)
CONFIGURE_FILE(composite.desktop.in composite.desktop)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

ADD_SUBDIRECTORY(src)

ENABLE_TESTING()

INSTALL(DIRECTORY data DESTINATION ${DATA_PATH}/..)
INSTALL(FILES ${CMAKE_BINARY_DIR}/composite.desktop DESTINATION "${CMAKE_INSTALL_PREFIX}/share/applications")
INSTALL(FILES ${CMAKE_SOURCE_DIR}/data/doc/composite_sampler.1
        DESTINATION share/man/man1)
INSTALL(FILES ${CMAKE_SOURCE_DIR}/data/doc/composite_midi.7
        DESTINATION share/man/man7)
INCLUDE(InstallRequiredSystemLibraries)

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Composite - Live performance sequencing, sampling, and looping")
SET(CPACK_PACKAGE_VENDOR "Composite Developers")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.txt")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")

SET(CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}")
IF(VERSION_SUFFIX)
    SET(CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}-${VERSION_SUFFIX}")
ENDIF(VERSION_SUFFIX)

#SET(CPACK_PACKAGE_INSTALL_DIRECTORY "LMMS ${VERSION}")
#IF(WIN32)
    #SET(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/data\\\\nsis_branding.bmp")
    #SET(CPACK_NSIS_MUI_ICON "${CMAKE_SOURCE_DIR}/data\\\\lmms.ico")
    #SET(CPACK_NSIS_INSTALLED_ICON_NAME "lmms.exe")
    #SET(CPACK_NSIS_DISPLAY_NAME "Linux MultiMedia Studio (LMMS)")
    #SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\lmms.sourceforge.net")
    #SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\lmms.sourceforge.net")
    #SET(CPACK_NSIS_CONTACT "lmms-devel@lists.sourceforge.net")
    #SET(CPACK_PACKAGE_EXECUTABLES "lmms.exe;Linux MultiMedia Studio")
    #SET(CPACK_NSIS_MENU_LINKS "lmms.exe;Linux MultiMedia Studio")
#ELSE(WIN32)
#    SET(CPACK_STRIP_FILES "bin/lmms;${PLUGIN_DIR}/*.so")
#    SET(CPACK_PACKAGE_EXECUTABLES "composite-gui" "Composite binary")
#ENDIF(WIN32)

SET(MACOSX_BUNDLE_ICON_FILE "${CMAKE_SOURCE_DIR}/data/img/gray/icon.svg")
SET(MACOSX_BUNDLE_GUI_IDENTIFIER "Composite")
SET(MACOSX_BUNDLE_LONG_VERSION_STRING "${VERSION}")
SET(MACOSX_BUNDLE_BUNDLE_NAME "Composite Sequencer")
SET(MACOSX_BUNDLE_SHORT_VERSION_STRING "${VERSION}")
SET(MACOSX_BUNDLE_BUNDLE_VERSION "${VERSION}")
SET(MACOSX_BUNDLE_COPYRIGHT "Jérémy Zurcher, 2009")

#SET(CPACK_SOURCE_GENERATOR "TBZ2")
#SET(CPACK_SOURCE_PACKAGE_FILE_NAME "composite-${VERSION}")
#INCLUDE(CPack)

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

######################################################################
### CONFIGURATION SUMMARY                                          ###
######################################################################

MESSAGE("\n"
"Overall Configuration Summary\n"
"-----------------------------\n"
"* Install Directory           : ${CMAKE_INSTALL_PREFIX}\n"
"* Data path                   : ${DATA_PATH}\n"
)

MESSAGE(
"\n"
"-----------------------------------------------------------------\n"
"FOR ADVANCED CONFIGURATION, USE ccmake INSTEAD OF cmake\n"
"\n"
"IMPORTANT:\n"
"after installing missing packages, remove CMakeCache.txt before\n"
"running cmake again!\n"
"-----------------------------------------------------------------\n"
)

=== src/Tritium/test/CMakeLists.txt ===
######################################################################
### Tritium Build Script (CMake)                                   ###
### http://gabe.is-a-geek.org/composite/                           ###
######################################################################
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

######################################################################
### TEST SOURCES AND BUILD                                         ###
######################################################################

IF(Boost_UNIT_TEST_FRAMEWORK_FOUND)
  FILE(GLOB_RECURSE test_HEADERS *.h ../Tritium/*.h ../src/*.h)

  CONFIGURE_FILE(test_config.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/test_config.hpp @ONLY)
  CONFIGURE_FILE(t_Serialization-default.h2song.in ${CMAKE_CURRENT_BINARY_DIR}/t_Serialization-default.h2song)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

  LIST(APPEND test_LIST
    t_TestTemplate
    t_SeqEvent
    t_SeqScript
    t_SeqScriptPrivate
    t_AudioPort
    t_Mixer
    t_Presets
    t_TritiumXml
    t_Serialization
    t_SimpleTransportMaster
    t_Song
    t_TransportPosition
    t_Sample
    t_ObjectBundle
    t_MidiImplementationBase
    t_DefaultMidiImplementation
    )

  ADD_DEFINITIONS("-DBOOST_TEST_DYN_LINK")
  ADD_DEFINITIONS("-DLADSPA_SUPPORT")
  ADD_DEFINITIONS("-DJACK_SUPPORT")

  ENABLE_TESTING()

  ADD_LIBRARY(test_utils_Tritium
    test_utils.cpp
    )

  FOREACH(T ${test_LIST})
    ADD_EXECUTABLE(${T}
      ${T}.cpp
      ${CMAKE_CURRENT_BINARY_DIR}/test_config.hpp
      ${test_INCLUDES}
      ${tritium_INCLUDES}
      )
    SET_SOURCE_FILES_PROPERTIES(${T}
      PROPERTIES
      COMPILE_FLAGS "-DBOOST_TEST_MAIN"
      )
    TARGET_LINK_LIBRARIES(${T}
      Tritium
      test_utils_Tritium
      ${Boost_UNIT_TEST_FRAMEWORK_LIBRARIES}
      )

    ADD_TEST(${T} ${T})
  ENDFOREACH(T ${test_LIST})

  ######################################################################
  ### CONFIGURATION SUMMARY                                          ###
  ######################################################################

  MESSAGE("\n"
  "Configuration Summary for Tritium Tests\n"
  "---------------------------------------\n"
  )

  MACRO(lib_report name)
    IF(${name}_FOUND)
      message("ENABLED..... ${name}")
    ELSE(${name}_FOUND)
      message("disabled.... ${name}")
    ENDIF(${name}_FOUND)
  ENDMACRO(lib_report)

  lib_report(Boost)
  lib_report(Boost_UNIT_TEST_FRAMEWORK)

ENDIF(Boost_UNIT_TEST_FRAMEWORK_FOUND)

=== src/3rd-party/lv2/lv2core-3.0/wscript ===
#!/usr/bin/env python
import Params
import autowaf
import sys

# Version of this package (even if built as a child)
LV2CORE_VERSION = '3.0'

# Variables for 'waf dist'
APPNAME = 'lv2core'
VERSION = LV2CORE_VERSION

# Mandatory variables
srcdir = '.'
blddir = 'build'

def set_options(opt):
	opt.add_option('--bundle-only', action='store_true', default=False, dest='bundle_only',
			help="Only install bundle (not header or pkg-config file)")
	autowaf.set_options(opt)

def configure(conf):
	autowaf.configure(conf)

def build(bld):
	if not Params.g_options.bundle_only:
		# Header
		install_files('INCLUDEDIR', '', 'lv2.h')
	
		# Pkgconfig file
		autowaf.build_pc(bld, 'LV2CORE', LV2CORE_VERSION, [])

	# Bundle (data)
	install_files('LV2DIR', 'lv2core.lv2', 'lv2core.lv2/lv2.ttl lv2core.lv2/manifest.ttl')

=== debian/changelog ===
composite (0.006-5) unstable; urgency=low

  * Apply patch from Ilya Barygin to fix FTBFS with binutils-gold;
    closes: #615702
  * Deapply patches after gbp'ing, abort on upstream changes.

 -- Alessio Treglia <alessio@debian.org>  Mon, 28 Feb 2011 12:33:12 +0100

composite (0.006-4) unstable; urgency=low

  * Depends on jackd (Closes: #591326).
  * Bump Standards.
  * Add patch from upstream's git to prevent FTBFS with newer QTs.

 -- Alessio Treglia <alessio@debian.org>  Mon, 02 Aug 2010 10:40:23 +0200

composite (0.006-3) unstable; urgency=low

  * Ignore .pc directory.
  * Install a symlink to libTritium.so in to /usr/lib.
  * Add patch to fix spelling errors.

 -- Alessio Treglia <alessio@debian.org>  Fri, 16 Jul 2010 19:54:42 +0200

composite (0.006-2) unstable; urgency=low

  * Add -DBG binary package.
  * Improve package description.
  * Pass --dbg-package parameter to dh_strip explicitly.

 -- Alessio Treglia <alessio@debian.org>  Wed, 14 Jul 2010 10:00:38 +0200

composite (0.006-1) unstable; urgency=low

  * Initial release (Closes: #588289).

 -- Alessio Treglia <alessio@debian.org>  Tue, 06 Jul 2010 15:26:09 +0200

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh --buildsystem=cmake $@

override_dh_auto_configure:
	dh_auto_configure -- -DWANT_LRDF=ON \
		-DCMAKE_BUILD_TYPE=RelWithoutDebInfo

override_dh_auto_install:
	dh_auto_install
	cd debian/tmp/usr/share/composite/data/i18n/ && \
		rm updateTranslations.sh stats.py

override_dh_strip:
	dh_strip --dbg-package=composite-dbg

override_dh_auto_test:

## composite 0.006.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,8 +12,8 @@
 PROJECT(composite)
 SET(VERSION_MAJOR "0")
 SET(VERSION_MINOR "006")
-#SET(VERSION_PATCH "")
-SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}")
+SET(VERSION_PATCH "1")
+SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
 ######################################################################
 ### CMAKE SETUP                                                    ###

## composite 0.006.2

=== debian/changelog ===
composite (0.006.2-1) unstable; urgency=low

  * New upstream stable release (Closes: ##634070).  

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sat, 23 Jul 2011 21:31:39 +0200

composite (0.006.1-1) unstable; urgency=low

  [ Jaromír Mikeš ]
  * New upstream stable release.  
  * Bump Standards
  * removed patches applied upstream
  * updated copyright file to rev. 174

  [ Alessio Treglia ]
  * Enable parallel builds.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sat, 16 Jul 2011 09:13:41 +0200

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 %:
-	dh --buildsystem=cmake $@
+	dh $@ --parallel --buildsystem=cmake
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DWANT_LRDF=ON \

## composite 0.006.2%2Bdfsg0

=== debian/changelog ===
composite (0.006.2+dfsg0-3) unstable; urgency=low

  * Set dh/compat 9
  * Fix VCS canonical URLs.
  * Bump standards.
  * Update copyright file.
  * Added Keywords entry to desktop file.
  * Fixed version mangling in watch file.
  * Added postinst postrm files.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 08 Aug 2013 01:56:40 +0200

composite (0.006.2+dfsg0-2) unstable; urgency=low

  * Replace lv2core with lv2-dev in Build-Depends.
  * debian/copyright:
    - Update to machine-readable format.
    - Group files by license.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Thu, 17 May 2012 10:40:59 +0200

composite (0.006.2+dfsg0-1) unstable; urgency=low

  [ Jaromír Mikeš ]
  * Provide xpm icon
  * Fix desktop file to be shipped in right package
  * Correct typo in cmake build type (s/RelWithoutDebInfo/RelWithDebInfo/)
    thanks to Gabriel Beddingfield

  [ Alessio Treglia ]
  * Remove an unnecessary copy of the waf blob (Closes: #654463).

 -- Alessio Treglia <alessio@debian.org>  Mon, 09 Jan 2012 20:16:58 +0100

## composite 0.006.2+dfsg0

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 PROJECT(composite)
 SET(VERSION_MAJOR "0")
 SET(VERSION_MINOR "006")
-SET(VERSION_PATCH "1")
+SET(VERSION_PATCH "2")
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
 ######################################################################

=== src/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

ADD_SUBDIRECTORY(Tritium)
ADD_SUBDIRECTORY(sampler)
ADD_SUBDIRECTORY(composite-gui)

ENABLE_TESTING()

=== data/doc/Makefile ===
###
### must have the following commandline tools:
###
### xml2po  (Debian package: poxml)
### po2xml  (Debian package: poxml)
### xmlto   (Debian package: xmlto)
### xmllint (Debian package: libxml2-utils)
###

MANUAL_MASTER = manual.docbook
TUTORIAL_MASTER = 

ALL_MASTERS = $(MANUAL_MASTER) $(TUTORIAL_MASTER)

ALL_MANUALS = manual_en.html

ALL_TUTORIALS = 

ALL_POT_FILES = manual_en.pot

XMLTO_OPTS = --stringparam section.autolabel=1 \
	--stringparam toc.max.depth=2 \
	--stringparam xref.with.number.and.title=0

XML2POT = xml2pot
XMLTO = xmlto
XMLLINT = xmllint
PO2XML = po2xml

all: all_manuals all_tutorials all_pot_files

all_manuals: $(ALL_MANUALS)

all_tutorials: $(ALL_TUTORIALS)

## Explicit build to avoid circular dependency
all_pot_files: $(ALL_MASTERS)
	$(XML2POT) manual.docbook   > manual.pot
	$(XML2POT) tutorial.docbook > tutorial.pot

clean:
	-rm -f $(ALL_MANUALS) $(ALL_TUTORIALS) *_{en,es,it,fr,nl,ca}.docbook *.docbook_validated

%.html: %.docbook %.docbook_validated
	LL=$$(echo -n $< | sed 's/.*_\(..\)\.docbook/\1/') ; \
	$(XMLTO) html-nochunks $(XMLTO_OPTS) \
		--stringparam l10n.gentext.language=$$LL \
		$<

%.docbook_validated: %.docbook
	$(XMLLINT) --noout --valid $^
	touch $@

## Special rule for master manual and tutorial
%_en.docbook: %.docbook
	cp -f $^ $@

manual_%.docbook: manual_%.po $(MANUAL_MASTER)
	$(PO2XML) $(MANUAL_MASTER) $< > $@

#manual_%.po: $(MANUAL_MASTER)
#	$(XML2POT) -u $@ $^

tutorial_%.docbook: tutorial_%.po $(TUTORIAL_MASTER)
	$(PO2XML) $(TUTORIAL_MASTER) $< > $@

#tutorial_%.po: $(TUTORIAL_MASTER)
#	$(XML2POT) -u $@ $^

=== src/Tritium/CMakeLists.txt ===
######################################################################
### Tritium Build Script (CMake)                                   ###
### http://gabe.is-a-geek.org/composite/                           ###
######################################################################
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

######################################################################
### REQUIRED LIBRARIES                                             ###
######################################################################

###
### LADSPA
###
add_definitions(-DLADSPA_SUPPORT)

###
### Qt 4 http://qt.nokia.com/
###

SET(QT_USE_QTXML true)
FIND_PACKAGE(Qt4 4.3.0 REQUIRED)
INCLUDE(${QT_USE_FILE})

###
### JACK http://jackaudio.org/
###
find_package(JACK REQUIRED)
include_directories(${JACK_INCLUDE_DIRS})
set(LIBS ${JACK_LIBRARIES})
add_definitions(-DJACK_SUPPORT)

###
### FLAC http://flac.sourceforge.net/
###
find_package(FLAC REQUIRED)
include_directories(${FLAC_INCLUDE_DIRS})
set(LIBS ${LIBS} ${FLAC_LIBRARIES})
add_definitions(-DFLAC_SUPPORT)

find_package(FLAC++ REQUIRED)
include_directories(${FLAC++_INCLUDE_DIRS})
set(LIBS ${LIBS} ${FLAC++_LIBRARIES})
add_definitions(-DFLAC_SUPPORT)

###
### libsndfile http://www.mega-nerd.com/libsndfile/
###
find_package(LibSndfile REQUIRED)
include_directories(${LibSndfile_INCLUDE_DIRS})
set(LIBS ${LIBS} ${LibSndfile_LIBRARIES})

### ...................................................
### Either libtar and libz, or libarchive are required.
### ...................................................

###
### libtar http://www.feep.net/libtar/
### Zlib http://www.zlib.net/
###
IF(NOT WANT_LIBARCHIVE)
  find_package(LibTar)
  find_package(ZLIB)
ENDIF(NOT WANT_LIBARCHIVE)
IF(LibTar_FOUND AND ZLIB_FOUND)
	include_directories(${LibTar_INCLUDE_DIRS} ${ZLIB_INCLUDE_DIRS})
	set(LIBS ${LIBS} ${LibTar_LIBRARIES} ${ZLIB_LIBRARIES})
ENDIF(LibTar_FOUND AND ZLIB_FOUND)

###
### libarchive http://code.google.com/p/libarchive/
###
IF(LibTar_FOUND AND ZLIB_FOUND)
ELSE(LibTar_FOUND AND ZLIB_FOUND)
       find_package(LibArchive REQUIRED)
       include_directories(${LibArchive_INCLUDE_DIRS})
       set(LIBS ${LIBS} ${LibArchive_LIBRARIES})
       add_definitions(-DLIBARCHIVE_SUPPORT)
ENDIF(LibTar_FOUND AND ZLIB_FOUND)

###
### Boost Framework http://www.boost.org/
### Used for unit testing
###
find_package(Boost 1.33 COMPONENTS unit_test_framework REQUIRED)
include_directories(${Boost_INCLUDE_DIRS})
IF(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} LESS 2.6)
	# CMake 2.4 didn't support module detection.  Turn it on
	# and hope for the best.  Don't know about 2.5.
	set(Boost_UNIT_TEST_FRAMEWORK_FOUND ON)
	set(Boost_UNIT_TEST_FRAMEWORK_LIBRARIES -lboost_unit_test_framework)
ENDIF(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} LESS 2.6)

######################################################################
### OPTIONAL LIBRARIES                                             ###
######################################################################

IF(WANT_LRDF)
  find_package(LRDF REQUIRED)
  include_directories(${LRDF_INCLUDE_DIRS})
  set(LIBS ${LIBS} ${LRDF_LIBRARIES})
  add_definitions(-DLRDF_SUPPORT)
ENDIF(WANT_LRDF)

######################################################################
### LIBRARY SOURCES AND BUILD                                      ###
######################################################################

FILE(GLOB_RECURSE tritium_SOURCES src/*.cpp src/*.cc src/*.c)
LIST(APPEND tritium_SOURCES ${CMAKE_SOURCE_DIR}/version.cpp)

FILE(GLOB_RECURSE tritium_INCLUDES Tritium/*.hpp src/*.hpp)
LIST(APPEND tritium_INCLUDES ${CMAKE_SOURCE_DIR}/version.h ${CMAKE_SOURCE_DIR}/config.h)

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR} .)
ADD_LIBRARY(Tritium SHARED ${tritium_SOURCES} ${CMAKE_BINARY_DIR}/version.cpp)

TARGET_LINK_LIBRARIES(Tritium
  ${QT_LIBRARIES}
  ${LIBS}
  )

SET_TARGET_PROPERTIES(Tritium
  PROPERTIES
  LINK_INTERFACE_LIBRARIES ""
  )

INSTALL(TARGETS Tritium LIBRARY DESTINATION lib)

######################################################################
### CONFIGURATION SUMMARY                                          ###
######################################################################

MESSAGE("\n"
"Configuration Summary for Tritium\n"
"---------------------------------\n"
)

MACRO(lib_report name)
  IF(${name}_FOUND)
    message("ENABLED..... ${name}")
  ELSE(${name}_FOUND)
    message("disabled.... ${name}")
  ENDIF(${name}_FOUND)
ENDMACRO(lib_report)

lib_report(QT4)
lib_report(JACK)
lib_report(LibSndfile)
lib_report(LRDF)
lib_report(FLAC)
lib_report(FLAC++)
lib_report(LibTar)
lib_report(ZLIB)
lib_report(LibArchive)
lib_report(Boost)
lib_report(Boost_UNIT_TEST_FRAMEWORK)

######################################################################
### UNIT TESTS                                                     ###
######################################################################

ADD_SUBDIRECTORY(test)
ENABLE_TESTING()

=== src/composite-gui/CMakeLists.txt ===
######################################################################
### Composite Build Script (CMake)                                 ###
### http://gabe.is-a-geek.org/composite/                           ###
######################################################################

CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

######################################################################
### REQUIRED LIBRARIES                                             ###
######################################################################

###
### LADSPA
###
add_definitions(-DLADSPA_SUPPORT)

###
### JACK (JACK support is required for libTritium, so we just
### need to set the flag since it used to be optional.)
###
add_definitions(-DJACK_SUPPORT)

###
### Qt 4 http://qt.nokia.com/
###

SET(QT_USE_QTNETWORK true)
SET(QT_USE_QTXML true)
FIND_PACKAGE(Qt4 4.3.0 REQUIRED)
INCLUDE(${QT_USE_FILE})

###
### Boost Framework http://www.boost.org/
### Used for unit testing
###
find_package(Boost 1.33 COMPONENTS unit_test_framework REQUIRED)
include_directories(${Boost_INCLUDE_DIRS})
IF(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} LESS 2.6)
	# CMake 2.4 didn't support module detection.  Turn it on
	# and hope for the best.  Don't know about 2.5.
	set(Boost_UNIT_TEST_FRAMEWORK_FOUND ON)
ENDIF(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} LESS 2.6)

######################################################################
### LIBRARY SOURCES AND BUILD                                      ###
######################################################################

FILE(GLOB_RECURSE composite_UIS *.ui)
FILE(GLOB_RECURSE composite_SRCS *.cpp)
FILE(GLOB_RECURSE composite_H *.hpp)

QT4_WRAP_UI(composite_UIS_H ${composite_UIS})
QT4_WRAP_CPP(composite_MOC ${composite_H}) 

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/src/Tritium
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR})

ADD_EXECUTABLE(composite-gui ${composite_SRCS} ${composite_MOC} ${composite_UIS_H})
TARGET_LINK_LIBRARIES(composite-gui
    Tritium
    ${QT_LIBRARIES}
    )

INSTALL(TARGETS composite-gui RUNTIME DESTINATION bin)

######################################################################
### CONFIGURATION SUMMARY                                          ###
######################################################################

MESSAGE("\n"
"Configuration Summary for Tritium\n"
"---------------------------------\n"
)

MACRO(lib_report name)
  IF(${name}_FOUND)
    message("ENABLED..... ${name}")
  ELSE(${name}_FOUND)
    message("disabled.... ${name}")
  ENDIF(${name}_FOUND)
ENDMACRO(lib_report)

lib_report(QT4)
lib_report(Boost)

=== src/sampler/CMakeLists.txt ===
######################################################################
### Composite Build Script (CMake)                                 ###
### http://gabe.is-a-geek.org/composite/                           ###
######################################################################

CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

######################################################################
### REQUIRED LIBRARIES                                             ###
######################################################################

FIND_PACKAGE(Qt4 4.3.0 COMPONENTS QtCore REQUIRED)
INCLUDE(${QT_USE_FILE})

######################################################################
### SOURCES AND BUILD                                              ###
######################################################################

LIST(APPEND LV2_SOURCES
  EngineLv2.hpp
  EngineLv2.cpp
  )

LIST(APPEND LV2_METADATA
  manifest.ttl
  composite_sampler.ttl
  )

INCLUDE(
  ${QT_USE_FILE}
)

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/src/Tritium
  ${CMAKE_SOURCE_DIR}/src/3rd-party/lv2
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  )

ADD_LIBRARY(composite_sampler MODULE
  ${LV2_SOURCES}
  )

TARGET_LINK_LIBRARIES(composite_sampler
  Tritium
  ${QT_LIBRARIES}
  )

SET_TARGET_PROPERTIES(composite_sampler
  PROPERTIES
  PREFIX ""
  )

INSTALL(TARGETS composite_sampler LIBRARY DESTINATION lib/lv2/composite_sampler.lv2)
INSTALL(FILES ${LV2_METADATA} DESTINATION lib/lv2/composite_sampler.lv2)

=== src/Tritium/test/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,13 @@
 ### http://gabe.is-a-geek.org/composite/                           ###
 ######################################################################
 CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
+
+if(COMMAND cmake_policy)
+  # Libraries linked via full path no longer produce linker search
+  # paths.
+  cmake_policy(SET CMP0003 NEW)
+endif(COMMAND cmake_policy)
+
 
 ######################################################################
 ### TEST SOURCES AND BUILD                                         ###
@@ -55,10 +62,15 @@
       PROPERTIES
       COMPILE_FLAGS "-DBOOST_TEST_MAIN"
       )
+    # Applications that use Tritium should /not/ have to
+    # link to QtCore.  However, in order to scaffold some
+    # of the tests, the link is necc.  (E.g. in t_AudioPort
+    # where we include a private header).
     TARGET_LINK_LIBRARIES(${T}
       Tritium
       test_utils_Tritium
       ${Boost_UNIT_TEST_FRAMEWORK_LIBRARIES}
+      ${QT_LIBRARIES}
       )
 
     ADD_TEST(${T} ${T})

=== debian/changelog ===
composite (0.006.2+dfsg0-7) unstable; urgency=medium

  * Team upload.

  [ Jaromír Mikeš ]
  * Patch forwarded.

  [ IOhannes m zmölnig (Debian/GNU) ]
  * More spelling fixes.
  * Use pkg-config for proper compiler-flags (Closes: #851028)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 12 Jan 2017 14:58:12 +0100

composite (0.006.2+dfsg0-6) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with Boost >= 1.59. (Closes: #811844)

 -- James Cowgill <jcowgill@debian.org>  Wed, 31 Aug 2016 21:10:08 +0100

composite (0.006.2+dfsg0-5) unstable; urgency=medium

  * Bump Standards.
  * Fix VCS fields.
  * Remove menu file.
  * Fix some hardening.
  * Update copyright file.
  * Replace scripts by triggers file.
  * Add patch to fix FTBFS with gcc-6 (Closes: #811844).
  * Fix more spelling.
  * Dropping dbg package.
  * Update watch file for gitlab.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 12 Jul 2016 13:44:40 +0200

composite (0.006.2+dfsg0-4) unstable; urgency=medium

  * Build-depend on zlib1g-dev (Closes: #750321).

 -- Alessio Treglia <alessio@debian.org>  Wed, 25 Jun 2014 19:32:35 +0100

=== debian/control ===
Source: composite
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
Build-Depends:
 cmake,
 debhelper (>= 9),
 pkg-config,
 libboost-dev,
 libboost-test-dev,
 libflac++-dev,
 libjack-dev,
 liblrdf-dev,
 libqt4-dev,
 libsndfile1-dev,
 libtar-dev,
 lv2-dev,
 zlib1g-dev,
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/composite.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/composite.git
Homepage: http://gabe.is-a-geek.org/composite/

Package: composite
Architecture: any
Depends:
 composite-data (>= ${source:Version}),
 jackd,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lv2-plugin
Description: Live performance sequencer
 Composite is a software application/system for real-time, in-performance
 sequencing, sampling, and looping. It has a strong emphasis on the needs
 of live performance improvisation. It is built around the Tritium audio
 engine, which also includes LV2 plugins.
 .
 This package contains the Composite Sampler Plugin (LV2) and the
 main GUI (composite-gui).

Package: composite-data
Architecture: all
Depends:
 ${misc:Depends},
Suggests:
 composite
Description: Live performance sequencer (data files)
 Composite is a software application/system for real-time, in-performance
 sequencing, sampling, and looping. It has a strong emphasis on the needs
 of live performance improvisation. It is built around the Tritium audio
 engine, which also includes LV2 plugins.
 .
 This package contains the data files for Composite.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DWANT_LRDF=ON \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_CXX_FLAGS="$(shell pkg-config --cflags lrdf) $(CXXFLAGS) $(CPPFLAGS)"

override_dh_auto_install:
	dh_auto_install
	cd debian/tmp/usr/share/composite/data/i18n/ && \
		rm updateTranslations.sh stats.py

override_dh_auto_test:

=== debian/watch ===
version=3
opts=dversionmangle=s/.dfsg\d+// \
 https://gitlab.com/composite/Composite/tags \/composite\/composite\/repository\/archive.tar.gz\?ref=composite-([\d.]*)
